module PARSER
    INTERFACE
        SUBROUTINE run(filename) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),  intent(in)  :: filename(*)
        END SUBROUTINE run

        SUBROUTINE get_int(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_INT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),  intent(in)    :: name(*)
            INTEGER   (KIND=C_INT),   intent(out)   :: value
        END SUBROUTINE get_int

        SUBROUTINE get_float(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_FLOAT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            REAL      (KIND=C_FLOAT),   intent(out)   :: value
        END SUBROUTINE get_float

        SUBROUTINE get_double(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_DOUBLE
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            REAL      (KIND=C_DOUBLE),  intent(out)   :: value
        END SUBROUTINE get_double

        ! TODO:
        SUBROUTINE get_char_len(name, len) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_INT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            INTEGER   (KIND=C_INT),     intent(out)   :: len
        END SUBROUTINE get_char_len

        SUBROUTINE get_char_c(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            CHARACTER (KIND=C_CHAR),    intent(out)   :: value(*)
        END SUBROUTINE get_char_c

        SUBROUTINE is_varname(name, status) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_INT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            INTEGER   (KIND=C_INT),     intent(out)   :: status
        END SUBROUTINE is_varname

    END INTERFACE  

    contains
    
    SUBROUTINE get_char_lenf(name, len) 
        IMPLICIT NONE
        CHARACTER, intent(in) :: name(*)
        INTEGER, intent(out)  :: len

        call get_char_len(name, len)
    END SUBROUTINE get_char_lenf

    SUBROUTINE get_charf(name, char_value) 
        IMPLICIT NONE
        CHARACTER, allocatable, intent(OUT) :: char_value(:)
        CHARACTER, intent(in) :: name(*)
        INTEGER :: len

        call get_char_lenf(name, len)

        IF(allocated(char_value)) deallocate(char_value)
        allocate(char_value(len))

        call get_char_c(name, char_value)
    END SUBROUTINE get_charf 

end module PARSER