#include "call_parser.h"
#include "config-parser.h"
#include <string>

static scm::ConfigParser Parser;

#ifdef __cplusplus
extern "C" {  
#endif  

    int runCXX(const char* filename)
    {
        bool res = Parser.run(filename);

        if(res == false) return 0;
        return 1;
    }

    int get_intCXX(const char* name, int* value)
    {
        bool res = Parser.get_value(name, value);

        if(res == false) return 0;
        return 1;
    }

    int get_floatCXX(const char* name, float* value)
    {
        bool res = Parser.get_value(name, value);

        if(res == false) return 0;
        return 1;
    }

    int get_doubleCXX(const char* name, double* value)
    {
        bool res = Parser.get_value(name, value);

        if(res == false) return 0;
        return 1;
    }

    int get_char_lenCXX(const char* name) 
    {
        std::string target_res;
        bool res = Parser.get_value(name, target_res);

        return target_res.size();
    }

    int get_charCXX(const char* name, char* value) 
    {
        std::string target_res;
        bool res = Parser.get_value(name, target_res);

        const int n = target_res.size();

        for (int i = 0; i < n; i++)
            value[i] = target_res[i];

        if(res == false) return 0;
        return 1;
    }

    void is_varnameCXX(const char* name, int* status)
    {
        bool flag = Parser.is_varname(name);
        (*status) = (int)flag;
    }

    // bool get_valueCXX(const char* name, std::string& value) 
    // {
    //     return Parser.get_value(name, value);
    // }

    // bool get_valueCXX(const char* name, bool* value) 
    // {
    //     return Parser.get_value(name, value);
    // }
#ifdef __cplusplus
}
#endif 